<form novalidate [formGroup]="form"  (ngSubmit)="onSubmit()">
  <table>
    <tr>
      <th>Name</th>
      <td>
        <input type="text" formControlName="name" />
      </td>
      <td>
        <ul *ngIf="fields.name.dirty && fields.name.invalid">
          <li *ngIf="fields.name.errors.required">Must not be empty</li>
          <li *ngIf="fields.name.errors.minlength">At least 5 chars</li>
        </ul>
      </td>
    </tr>

    <tr>
      <th>Age</th>
      <td>
        <input type="number" formControlName="age" />
      </td>
      <td>
        <ul *ngIf="fields.age.dirty && fields.age.invalid">
          <li *ngIf="fields.age.errors.min">Must be 18 or older</li>
          <li *ngIf="fields.age.errors.max">Must be less than 100</li>
        </ul>
      </td>
    </tr>

    <tr>
      <th>Date</th>
      <td>
        <input type="date" formControlName="created"  />
      </td>
      <td>
        <ul *ngIf="fields.created.dirty && fields.created.invalid">
          <li *ngIf="fields.created.errors.required">Must not be empty</li>
        </ul>
      </td>
    </tr>

    <tr>
      <th></th>
      <td>
        <button type="submit" [disabled]="form.invalid">REGISTER</button>
      </td>
    </tr>
  </table>
</form>
